"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/theming.tsx
var theming_exports = {};
__export(theming_exports, {
  EmotionThemeContextSymbol: () => EmotionThemeContextSymbol,
  EmotionThemeProvider: () => EmotionThemeProvider,
  createThemeCache: () => createCacheWithTheme,
  useEmotionTheme: () => useEmotionTheme,
  weakMemoize: () => weakMemoize
});
module.exports = __toCommonJS(theming_exports);
var import_weak_memoize = __toESM(require("@emotion/weak-memoize"));
var import_vue_utils = require("@chakra-ui/vue-utils");

// src/utils.ts
var getTheme = /* @__PURE__ */ __name((outerTheme, theme) => {
  if (typeof theme === "function") {
    const mergedTheme = theme(outerTheme);
    if (process.env.NODE_ENV !== "production" && (mergedTheme == null || typeof mergedTheme !== "object" || Array.isArray(mergedTheme))) {
      throw new Error("[EmotionThemeProvider] Please return an object from your theme function, i.e. theme={() => ({})}!");
    }
    return mergedTheme;
  }
  if (process.env.NODE_ENV !== "production" && (theme == null || typeof theme !== "object" || Array.isArray(theme))) {
    throw new Error("[EmotionThemeProvider] Please make your theme prop a plain object");
  }
  return {
    ...outerTheme,
    ...theme
  };
}, "getTheme");

// src/theming.tsx
function weakMemoize(...args) {
  return typeof import_weak_memoize.default === "function" ? (0, import_weak_memoize.default)(...args) : import_weak_memoize.default.default(...args) ? import_weak_memoize.default.default(...args) : (0, import_weak_memoize.default)(...args);
}
__name(weakMemoize, "weakMemoize");
var [_EmotionThemeProvider, useEmotionTheme, EmotionThemeContextSymbol] = (0, import_vue_utils.createContext)({
  strict: false,
  name: "EmotionThemeContext"
});
var createCacheWithTheme = /* @__PURE__ */ weakMemoize((outerTheme) => {
  return weakMemoize((theme) => {
    return getTheme(outerTheme, theme);
  });
});
function EmotionThemeProvider(theme) {
  let _theme = useEmotionTheme();
  if (theme !== _theme) {
    _theme = createCacheWithTheme(_theme)(theme);
  }
  _EmotionThemeProvider(_theme);
}
__name(EmotionThemeProvider, "EmotionThemeProvider");
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  EmotionThemeContextSymbol,
  EmotionThemeProvider,
  createThemeCache,
  useEmotionTheme,
  weakMemoize
});
